//This line allows access to the Trakr functions library
#include "svt.h"

//The code in Start will be run before anything else
void Start()
{
	OpenGraphics();	//Allows access to the graphics system
}

//The code in Run will be run over and over until the function returns False instead of True
bool Run()
{
	//Check if it's time to quit
	if (GetRemoteKeys() & KEY_HOME)
		return false;
	ClearScreen();
	//This next line writes some text on the screen, it doesn't actually appear until the Show() command
	DrawText( 5, 30, "TRAKR" );
	Show();  //This line causes pending updates for the Trakr's remote to be displayed

	Sleep( 1000 );  //This line waits for one second, which is 1000 milliseconds.

	//Now we've displayed the word 'TRAKR' onscreen, waited one second, we can clear the screen
	//and write a different word and wait again
	ClearScreen();
	DrawText( 5, 30, "ROCKS" );
	Show();

	Sleep( 1000 );

	return true;  //restart the Run function again
}

//The code in End will run after Run has returned false
void End()
{
	CloseGraphics();  //This line relinquishes control of the graphics system
}

