
#include "svt.h"
int LastKeyState;

void Start(){
  OpenGraphics();
}

void End(){
  CloseGraphics();
}

// consolidating code by declaring a custom function:
void display(int keyState)
{
  ClearScreen();
  DrawText( 5, 0, "Key: %d", keyState  ); //show the 8 bits of keyState as an integer
  int y=30; // variable to increment text display downward

  if(keyState&KEY_LEFT_BACK){ //  if bit in "keyState" associated with "KEY_LEFT_BACK" is high
    DrawText( 5, y, "LEFT BACK" );// draw text
    y=y+15; //move text "pen" down
  }

  if(keyState&KEY_LEFT_FORWARD){
    DrawText( 5, y, "LEFT FORWARD" );
    y=y+15;
  }

  if(keyState&KEY_RIGHT_BACK){
    DrawText( 5, y, "RIGHT BACK" );
    y=y+15;
  }

  if(keyState&KEY_RIGHT_FORWARD){
    DrawText( 5, y, "RIGHT FORWARD" );
    y=y+15;
  }

  if(keyState&KEY_INPUT1){
    DrawText( 5, y, "LEFT INPUT" );
    y=y+15;
  }

  if(keyState&KEY_INPUT2){
    DrawText( 5, y, "RIGHT INPUT" );
    y=y+15;
  }

  if(keyState&KEY_RUN){
    DrawText( 5, y, "GO" );
    y=y+15;
  }

  if(keyState&KEY_MENU){
    DrawText( 5, y, "MENU" );
    y=y+15;  //move draw "pen" down
  }

  if(keyState==0){
    DrawText( 5, 30, "NONE PRESSED" );
  }

  Show();
}

bool Run()
{
  int KeyState = GetRemoteKeys(); // load button states into variable
  if (KeyState & KEY_HOME)
  	return false;

  if(LastKeyState!=KeyState) // if buttons are in a new state...
  {
	display(KeyState);// show the names of pressed buttons
	LastKeyState=KeyState;// update the old state to the new one
  }
  Sleep(100); // no need to keep the radio channel full all the time.
  return true;
}
