#ifndef __AUDIO_H__
#define __AUDIO_H__

#include "Trakr.h"
#include "Apu.h"
#include "Adc.h"

typedef struct
{
  unsigned short wFormatTag;
  unsigned short wChannels;
  unsigned int dwSamplesPerSec;
  unsigned int dwAvgBytesPerSec;
  unsigned short wBlockAlign;
  unsigned short wBitsPerSample;
}sWAVE_FORMAT;
 
typedef struct
{
  unsigned int flag;
  int FileHandle;
  //ram
  unsigned char *pRamBuffer;
  unsigned int RamMax;
  unsigned int BufferOffset;
  unsigned int BufferCount;
  //file
  unsigned char* pBuffer;
  unsigned int FileSize;
  unsigned int FileLen;
  unsigned int FilePos;
  unsigned int FileHeaderLen;
  unsigned int DataLen;
  unsigned int DataPos;
  sWAVE_FORMAT sFmt;
  unsigned char FileName[256];
}TAG_HANDLE;

extern bool SVT_WAV_Play(const char * pFiLename, TAG_HANDLE* pWave);
extern bool SVT_WAV_Is_Busy(TAG_HANDLE *Handle);
extern bool SVT_WAV_Record(const char * pFileName, TAG_HANDLE *pWave);
extern bool SVT_WAV_Recording(TAG_HANDLE *Handle);
extern void SVT_WAV_Stop(TAG_HANDLE *Handle);

#endif
