
#define OSD_CMD_MAX_SIZE  (2*1024)
volatile char CMD_Buf[OSD_CMD_MAX_SIZE]__attribute__((aligned(256)));
volatile char *pCmd;
#define CMD_ID                     "CMDS"
#define CMD_SID_ENDS               "ENDS"
#define CMD_SID_MASKOPEN           0
#define CMD_SID_MASKCLOSE          1
#define CMD_SID_OPEN               2
#define CMD_SID_SHOW               3
#define CMD_SID_CLOSE              4
#define CMD_SID_DRAWRECTANGLE      5
#define CMD_SID_SETRECTANGLE       6
#define CMD_SID_TEXT               7
#define CMD_SID_BITMAP             8
#define CMD_SID_SETSCREEN          9

void SVT_ROsd_Yuv_Mask_Open(unsigned int Cb, unsigned int Cr)
{
  char* pb;
  char* pr;
  Cb=Cb<0x4000?Cb:0x4000;
  Cr=Cr<0x4000?Cr:0x4000;
  pb=(char*)Cb;
  pr=(char*)Cr;
  *pCmd++=CMD_SID_MASKOPEN;
  *pCmd++=*pb++;
  *pCmd++=*pb++;
  *pCmd++=*pr++;
  *pCmd++=*pr++;
}

void SVT_ROsd_Yuv_Mask_Close(void)
{
  *pCmd++=CMD_SID_MASKCLOSE;
}
void SVT_ROsd_Open(void)
{
  pCmd=(char*)CMD_Buf;
  SVT_Memory_Copy(pCmd,CMD_ID,4);
  pCmd+=6;
  *pCmd++=CMD_SID_OPEN;
}
void SVT_ROsd_Show(void)
{
  unsigned short Length;
  if((unsigned int)pCmd==(unsigned int)CMD_Buf)
    return;
  *pCmd++=CMD_SID_SHOW;
  Osd_Set_Symbol(pCmd,CMD_SID_ENDS);
  Length=pCmd-CMD_Buf;
  SVT_Memory_Copy((char*)(CMD_Buf+4),&Length,2);
  Debug_TransFile((unsigned char*)CMD_Buf,Length+4);
  pCmd=(char*)CMD_Buf;
  SVT_Memory_Copy(pCmd,CMD_ID,4);
  pCmd+=6;
}
void SVT_ROsd_Close(void)
{
  *pCmd++=CMD_SID_CLOSE;
}

void SVT_ROsd_Draw_Rectangle(
  int lx,
  int ty,
  int rx,
  int by,
  TAG_COLOR *rgba)
{
  *pCmd++=CMD_SID_DRAWRECTANGLE;
  signed short slx=lx,sty=ty,srx=rx,sby=by;
  SVT_Memory_Copy(pCmd+0,(char*)&slx,2);
  SVT_Memory_Copy(pCmd+2,(char*)&sty,2);
  SVT_Memory_Copy(pCmd+4,(char*)&srx,2);
  SVT_Memory_Copy(pCmd+6,(char*)&sby,2);
  pCmd+=8;
  *pCmd++=rgba->R;
  *pCmd++=rgba->G;
  *pCmd++=rgba->B;
  *pCmd++=*((char*)&Linewidth);
}
void SVT_ROsd_Clear_Rectangle(
            int lx,
            int ty,
            int rx,
            int by)
{
  TAG_COLOR cl={0,0,0,1};
  SVT_ROsd_Set_Rectangle(lx,ty,rx,by,&cl);
}

int  SVT_ROsd_Draw_Text(int x, int y, char * fmt,...)
{
  signed short slb=tLeftBoundary,srb=tRightBoundary,sci=tCharInterval,sli=tLineInterval,sx=x,sy=y;
  va_list arg;
  unsigned short len;
  va_start (arg, fmt);
  len = (unsigned short)kprintf(stdout, fmt, arg)+1;
  va_end (arg);
  *pCmd++=CMD_SID_SETRECTANGLE;
  SVT_Memory_Copy(pCmd+0,(char*)&len,2);
  SVT_Memory_Copy(pCmd+2,(char*)&slb,2);
  SVT_Memory_Copy(pCmd+4,(char*)&srb,2);
  SVT_Memory_Copy(pCmd+6,(char*)&sci,2);
  SVT_Memory_Copy(pCmd+8,(char*)&sli,2);
  pCmd+=10;
  *pCmd++=tColor.R;
  *pCmd++=tColor.G;
  *pCmd++=tColor.B;
  *pCmd++=tColor.Transparent;
  SVT_Memory_Copy(pCmd,(char*)&sx,2);
  SVT_Memory_Copy(pCmd+2,(char*)&sy,2);
  pCmd+=4;
  SVT_Memory_Copy(pCmd,stdout,len);
  pCmd+=len;
  return len;
}
void SVT_ROsd_Draw_Bitmap(
            char BmpIndex,
            int x,
            int y,
            TAG_COLOR *cTransparent)
{
  signed short sx=x,sy=y;
  *pCmd++=CMD_SID_BITMAP;
  SVT_Memory_Copy(pCmd+0,(char*)&sx,2);
  SVT_Memory_Copy(pCmd+2,(char*)&sy,2);
  pCmd+=4;
  *pCmd++=cTransparent->R;
  *pCmd++=cTransparent->G;
  *pCmd++=cTransparent->B;
  *pCmd++=cTransparent->Transparent;
  *pCmd++=BmpIndex;
}

void SVT_ROsd_Set_Rectangle(
            int lx,
            int ty,
            int rx,
            int by,
            TAG_COLOR *rgba)
{
  *pCmd++=CMD_SID_SETRECTANGLE;
  signed short slx=lx,sty=ty,srx=rx,sby=by;
  SVT_Memory_Copy(pCmd+0,(char*)&slx,2);
  SVT_Memory_Copy(pCmd+2,(char*)&sty,2);
  SVT_Memory_Copy(pCmd+4,(char*)&srx,2);
  SVT_Memory_Copy(pCmd+6,(char*)&sby,2);
  p+=8;
  *pCmd++=rgba->R;
  *pCmd++=rgba->G;
  *pCmd++=rgba->B;
  *pCmd++=rgba->Transparent;
}

void SVT_ROsd_Set_Screen(TAG_COLOR *rgba)
{
  *pCmd++=CMD_SID_SETSCREEN;
  *pCmd++=rgba->R;
  *pCmd++=rgba->G;
  *pCmd++=rgba->B;
  *pCmd++=rgba->Transparent;
}

void SVT_ROsd_Clear_Screen(void)
{
  TAG_COLOR cl={0,0,0,1};
  SVT_ROsd_Set_Screen(&cl);
}

