/************************************************************************
*							JAPI.h										*
*				V1.0.1	Jerry.Wang ()	2010 01 05					*
*			+8615012667981	jerry.wang@sz.newspirit.com.hk				*
*		New Spirit Electronic Technology Development(Shenzhen)Co.,Ltd.	*
************************************************************************/

/* Default linker script, for normal executables */
OUTPUT_FORMAT("elf32-littlearm", "elf32-bigarm",
	      "elf32-littlearm")
OUTPUT_ARCH(arm)
ENTRY(_start)
/*ENTRY(main)*/

/*--------------------------------------------------------------------------*/
/* needed by C Run-time library (crt0.o)                                    */
/*--------------------------------------------------------------------------*/
PROVIDE ( hardware_init_hook = 0);
PROVIDE ( software_init_hook = 0);
PROVIDE ( __rom_image = 0);
PROVIDE ( HandlerUndef = 0x04);
PROVIDE ( HandlerSWI    = 0x08); 
PROVIDE ( HandlerPabort = 0x0C);
PROVIDE ( HandlerDabort = 0x10);
PROVIDE ( HandlerIRQ    = 0x18);
PROVIDE ( HandlerFIQ    = 0x1C);
/*--------------------------------------------------------------------------*/
/*PROVIDE __WJ_APP_START__;*/
/*PROVIDE __WJ_APP_STACK__;*/
/*---------------------------------------------------------------------*/
MEMORY
{
	ram : ORIGIN = 0x00200000, LENGTH = 0x00600000	/*6M*/
}

SECTIONS
{
	/* initialize location counter */
	. = 0x00200000;
	
	.startup 0x00200000 :
	{
		*(.startup*)
	} > ram
	.text : /* 0x00200000 :*/
	{
	    *(.text* .stub .gnu.linkonce.t.*)
	    /* .gnu.warning sections are handled specially by elf32.em.  */
	    *(.gnu.warning)
	    *(.glue_7t) *(.glue_7)
	} > ram
	
	.init :	{ KEEP (*(.init)) } > ram =0
	.fini : { KEEP (*(.fini)) } > ram =0
	.rodata : { *(.rodata* .gnu.linkonce.r.*) } > ram
 	.eh_frame :	{ KEEP (*(.eh_frame)) } > ram
 	
 	.ctors :
	{
	    /* gcc uses crtbegin.o to find the start of
	       the constructors, so we make sure it is
	       first.  Because this is a wildcard, it
	       doesn't matter if the user does not
	       actually link against crtbegin.o; the
	       linker won't look for a file to match a
	       wildcard.  The wildcard also means that it
	       doesn't matter which directory crtbegin.o
	       is in.  */
		KEEP (*crtbegin.o(.ctors))
	    /* We don't want to include the .ctor section from
	       from the crtend.o file until after the sorted ctors.
	       The .ctor section from the crtend file contains the
	       end of ctors marker and it must be last */
	    KEEP (*(EXCLUDE_FILE (*crtend.o ) .ctors))
	    KEEP (*(SORT(.ctors.*)))
	    KEEP (*(.ctors))
	} > ram
	
	.dtors :
	{
	    KEEP (*crtbegin.o(.dtors))
	    KEEP (*(EXCLUDE_FILE (*crtend.o ) .dtors))
	    KEEP (*(SORT(.dtors.*)))
	    KEEP (*(.dtors))
	} > ram
	
	.jcr : { KEEP (*(.jcr))	} > ram
 	
	/*----------------------------------------------------------------------*/
	/* initialized data section information (.data)                         */
	/*----------------------------------------------------------------------*/
	__erom = .;				/* for C Run-time library (crt0.o) */

	/*----------------------------------------------------------------------*/
	/*	vrom section, for GPU used											*/
	/*----------------------------------------------------------------------*/
	
	/* Adjust the address for the BG 256 boundaries segment.*/
	/*.vrom :		
	{					
		. = ALIGN(256);
	  	_svrom = .;
	  	_VROM_BASE = .;
	    KEEP(*(.vrom))
	  	_evrom = .;
	} > ram
	_VROM_SECTION_SIZE = SIZEOF(.vrom); */

	.data : 
	{
		__data_start = . ;
		*(.data* .gnu.linkonce.d.*)
		SORT(CONSTRUCTORS)
	} > ram
	_edata = .;				/* for C Run-time library (crt0.o) */
	
	__app_end__ = .;
	
	/*----------------------------------------------------------------------*/
	/* uninitialized data section information (.bss)                        */
	/*----------------------------------------------------------------------*/
	__bss_start__ = .;		/* for C Run-time library (crt0.o) */
	.bss : 
	{ 
		*(.bss*) 
	} > ram
	__bss_end__ = .;		/* for C Run-time library (crt0.o) */
	
  	
	PROVIDE (end = .);		/* for C Run-time library (crt0.o) */
}
