/*
 *
#include "svt.h"


void Start()
{
  OpenGraphics();
}

bool Run()
{

  ClearScreen();
  DrawText( 5, 30, "TRAKR" );
  Show();

  Sleep( 1000 );

  ClearScreen();
  DrawText( 5, 30, "ROCKS" );
  Show();

  Sleep( 1000 );

  return true;
}

void End()
{
  CloseGraphics();
}

*/

#include "svt.h"
#include "..\Internals\trakr.h"

void Say(char s[]) // DrawText's the char array
{
  Color GREEN;
  GREEN.R = 0;
  GREEN.G = 255;
  GREEN.B = 0;
  GREEN.Transparent = 0;
  SetTextColor(GREEN);
  ClearRectangle( 5, 35, 150, 65 );
  DrawText( 5, 35, s );
}

void SayNum(int Num) // Same as above, but for a number.
{
  Color GREEN;
  GREEN.R = 0;
  GREEN.G = 255;
  GREEN.B = 0;
  GREEN.Transparent = 0;
  SetTextColor(GREEN);
  ClearRectangle( 5, 5, 150, 30 );
  DrawText(5, 5, "Number: %d", Num );
}

const int x_initial_offset = 80;
const int y_initial_offset = 80;
int x_offset=80;
int y_offset=119;
const int secondsForA360=6;

void Start()
{
  OpenGraphics();
}

int lastNum = -1;
int direction = 0;

bool Run()
{
  if( GetRemoteKeyStatus( KEY_HOME ) )
    return false;

  int RemK = GetRemoteKeys();
  if( RemK != lastNum )
  {
    lastNum = RemK;
    if( GetRemoteKeyStatus( KEY_RIGHT_FORWARD ) && GetRemoteKeyStatus( KEY_LEFT_FORWARD ) ) {
      Say("Both Forward.");
      direction = 1;
    }
    else {
      if( GetRemoteKeyStatus( KEY_RIGHT_BACK ) && GetRemoteKeyStatus( KEY_LEFT_BACK ) ) {
        Say("Both Back.");
        direction = -1;
      }
      else {
        Say( "" );
        direction = 0;
      }
    }

    SayNum(RemK);
    Show();
    ResetTimer();
  }

  if ( ReadTimer() > 500 )
  {
    ResetTimer();

    if ( direction != 0 ) {
      x_offset += direction;

      Color White;
      White.R = 255;
      White.G = 255;
      White.B = 255;
      White.Transparent = 0;

      ClearRectangle( 0, SCREEN_HEIGHT - 5, 159, SCREEN_HEIGHT - 1  );

      SetLineWidth(3);
      if ( x_offset < x_initial_offset )
        DrawRectangle(x_offset, y_initial_offset, x_initial_offset, y_offset, White);
      if ( x_offset > x_initial_offset )
        DrawRectangle(x_initial_offset, y_initial_offset, x_offset, y_offset, White);
      Show();

    }
}
  return true;
}

void End()
{
  CloseGraphics();
}
